-- Rolling Start App.
-- Made by R_areL_
-- Version 0.81

local PP = 0
local FR = 0
local FCI = {}
local Fgap = 4
local Side = {}
local Tgap = {}
local Sgap = {}
local start = {}
local leader = 0
local Offset = {}
local TimerF2 = 0
local OffsetL = 0
local OffsetR = 0
local position = {}
local Formation = 0
local BrakeForce = {}
local LimitSpeed = 80
local MaxOffset = 0.4
local LimitSpeed2 = {}
local gridposition = {}
local RollingStart = false
local carcount = ac.getSim().carsCount-1
local meter = 1/ac.getSim().trackLengthM

if ac.getSim().isOnlineRace then
	return nil
end

function toboolean(value)
	if tostring(value) == 'true' then
	  return true
	end
	if tostring(value) == 'false' then
	  return false
	end
	return nil
end


function script.update(dt)

	if ac.getSim().raceSessionType == 3 then

		for i=0,carcount do

			if ac.getSim().sessionTimeLeft >= 1 then

				position[i] = ac.getCar(i).racePosition
				Offset[i] = ac.worldCoordinateToTrack(ac.getCar(i).position).x

				if ac.getCar(i).racePosition == 1 then
					PP = ac.getCar(i).index
				elseif ac.getCar(i).racePosition == 2 then
					FR = ac.getCar(i).index
				end

				if ac.worldCoordinateToTrack(ac.getCar(PP).position) <= ac.worldCoordinateToTrack(ac.getCar(FR).position) then
					string = 1
				else 
					string = 0
				end

				gridposition[i] = math.fmod(ac.getCar(i).racePosition,2)

				if ac.getCar(i).racePosition == 1 then
					leader = ac.getCar(i).index
				end
				
				for j=0,carcount do
					if (ac.getCar(j).racePosition == ac.getCar(i).racePosition-1) then
						FCI[i] = ac.getCar(j).index
					end	
				end
			end

			------------------------------------------------------------------------------
			
			Tgap[i] = ac.getGapBetweenCars(FCI[i],i)
			Sgap[i] = (ac.getCar(leader).splinePosition - ac.getCar(i).splinePosition)
			
			if ac.getCar(leader).splinePosition <= (1-(meter*1200)) then
				LimitSpeed2[i] = math.max(LimitSpeed-50,math.min(LimitSpeed-((Tgap[i]+1)*15),LimitSpeed+40))
				Formation = 1
			else
				if ac.getCar(leader).splinePosition <= (1-(meter*1195)) then
					Formation = 2
				end
				LimitSpeed2[i] = math.min( LimitSpeed+(Sgap[i]/meter-(Fgap*position[i]))*2,LimitSpeed+40)
				
			end
			if ac.getCar(i).splinePosition > 0.98 and (ac.getCar(FCI[i]).splinePosition < ac.getCar(i).splinePosition) then
				LimitSpeed2[i] = LimitSpeed 
			end
			
			
			if ac.getCar(i).speedKmh >= 60 then
				start[i] = 0
			end

			
			if start[i] == 0 then
				if Offset[i] > 0 then
					Offset[i] = math.max(0,Offset[i]-dt/5)
				else 
					Offset[i] = math.min(0,Offset[i]+dt/5)
				end
			end

			if ac.getCar(leader).lapCount >= 1 then
				Formation = 2
			end

			BrakeForce[i] =  math.max(-105000,((ac.getCar(i).speedKmh - LimitSpeed2[i])*-10000))
			------------------------------------------------------------------------------

			if Formation == 2 then	
				OffsetL = math.max(MaxOffset*-1,OffsetL-dt/10)
				OffsetR = math.min(MaxOffset,OffsetR+dt/10)
			else
				OffsetL = math.min(0,OffsetL+dt/10)
				OffsetR = math.max(0,OffsetR-dt/10)
			end

			if RollingStart == true and ac.getSim().isPaused == false then

				if ac.getSim().sessionTimeLeft/1000 >= 0.7*ac.getCar(i).racePosition*-1 then
					physics.setAIThrottleLimit(i, 0)
				else
					physics.setAIThrottleLimit(i, 1)
				end

				physics.setAISplineOffset(i, Offset[i], false)

				if ac.getCar(leader).lapCount < 1 then
					if ac.getCar(i).index == leader then
						physics.setAITopSpeed(leader, LimitSpeed)
					else
						if ac.getCar(i).speedKmh >= LimitSpeed2[i]+1 then
							physics.addForce(i, vec3(0,0.25,-1), true, vec3(0,0,-21000) ,true)
						end
						physics.setAITopSpeed(i, LimitSpeed2[i])
					end
				else
					physics.setAITopSpeed(i, math.huge)
					physics.addForce(i, vec3(0,0,0), true, vec3(0,0,0) ,true)
				end
				if Formation == 2 then
					TimerF2 = TimerF2 + dt
					if gridposition[i] == string then
						Side[i] = "Right"
						physics.setAISplineOffset(i, OffsetR, false)
					else
						Side[i] = "Left"
						physics.setAISplineOffset(i, OffsetL, false)
					end
				end

				if ac.getSim().sessionTimeLeft <= 0 and ac.getSim().sessionTimeLeft >= -100 then
					ac.setMessage("Race Control","Line up single file")
				elseif Formation == 2 then
					if TimerF2 <= 5 then
						ac.setMessage("Race Control","Line up single file")
					elseif ac.getCar(leader).lapCount == 0 then
						ac.setMessage("Keep"..Side[0],(Sgap[0]/meter-(Fgap*position[0])))
					end
				end
				if ac.getCar(leader).lapCount == 1 and ac.getCar(leader).splinePosition <= 0.01 then
					ac.setMessage("Race Control","Green flag Race start")
				end

			end
		end

	end

	
	
	ac.debug("0.Rolling Start",RollingStart)
	ac.debug("1.Limit Speed",LimitSpeed)
	ac.debug("2.Formation Gap",Fgap)
	ac.debug("3.AI Spline Offset",MaxOffset)
	
end

function script.windowRSP(dt)

	if ui.checkbox('Rolling start', RollingStart) then
		RollingStart = not RollingStart
	end

	Volume, changed = ui.slider('Limit Speed', LimitSpeed, 60, 100, '%.0f')
	if changed then
		LimitSpeed = Volume
	end

	Volume, changed = ui.slider('Formation Gap', Fgap, 4, 10, '%.0f')
	if changed then
		Fgap = Volume
	end

	Volume, changed = ui.slider('AI Spline Offset', MaxOffset, 0.2, 0.8, '%.2f')
	if changed then
		MaxOffset = Volume
	end

	ui.text("Rolling Start Config App")

end